#!/usr/local/pub/bin/gawk -f
# this script displays the title, name and time for all albums

BEGIN {
	FS = "|"

	# album line

	ARTIST		= 1		# name of artist
	TITLE		= 2		# title of album
	DATE		= 3		# date published
	LABEL		= 4		# label name
	CATALOG		= 5		# catalogue number

	# cut line
	CUTNAME		= 1		# name of cut
	TIME		= 2		# time of cut
	CUTART		= 3		# artist, if different than album line
}

substr($0,1,1) == "\t" {		# cut line
	ncut = split(substr($0,2),Flds,"|")		# get time
	if (ncut > 1) TotTime += Time($TIME)	# add time
	next
}

{		# album line
	if (length(Album) > 0) PrtAlb()

	Album = CleanUp($0)
	TotTime = 0
}

func Time(str) {		# compute time in seconds
	if ((x = split(str,Flds,":")) != 2) return 0
	else return (Flds[1] * 60 + Flds[2])
}

func PrtAlb() {	# print last album
	print Album "|" OutTime(TotTime)
}

func OutTime(str) {		# convert seconds to Min:Sec
	Sec = str % 60
	Min = (str - Sec) / 60

	return (Min ":" Sec)
}

func CleanUp(str) {	# clean CR from line if there
	if (substr(str,length(str)) == "\r") ret = substr(str,1,length(str)-1)
	else ret = str
	return ret
}
