/*
 *
 * (c) Copyright 1992 by William R. Pringle - all rights reserved
 *
 *				**** DEFINE ****
 *
 * This file contains the definition for external variables
 *	declared in cd.h
 *
 */

#define EXTERN	/* define */

#include <stdio.h>
#include "cd.h"

init()
{		/* initialize all kinds of variables */
	int		i;

	debugsw = 0;		/* turn off debugging */

	max_open = 5;		/* max data files open at one time */
	tot_albums = 0L;		/* no albums */
	mast_file = art_file = tit_file = NULL;	/* no files open */
	for (i=0; i < MAXNDX; i++)
	{		/* loop thru index & data structures */
		datafile[i].df_fp = NULL;
		datafile[i].df_time = 0L;
		datafile[i].df_fname = NULL;
	}

	tkeep = 0;			/* no albums kept yet */
	for (i=0; i < MAXKEEP; i++)
	{
		keep[i].ka_name = NULL;		/* no title */
		keep[i].ka_art  = NULL;		/* no artist */
		keep[i].ka_beg  = 0;		/* no cuts */
		keep[i].ka_end  = 0;		/* yet */
	}

	for (i=0; i < MAXCUTS; i++)
	{
		cuts[i].cut_nrec = 0;		/* no album yet */
		cuts[i].cut_num  = 0;		/* no cut yet, either */
		cuts[i].cut_name = NULL;	/* no title */
		cuts[i].cut_art  = NULL;	/* no artist */
		cuts[i].cut_min  = 0;		/* no minutes */
		cuts[i].cut_sec  = 0;		/* no seconds */
	}

	tapelen = 45*60;				/* default length of tape side */
	tapeside = 0;					/* default side 1 */
	for (i=0; i < MAXSIDES; i++) zap_tape_side(i);
}

zap_tape_side(i)
int		i;		/* tape side to zap  */
{		/* clear out a tape side */
	int		j;

	tapes[i].ts_name = NULL;	/* no title for tape */
	tapes[i].ts_art  = NULL;	/* no artist for tape */
	tapes[i].ts_num   = 0;		/* no cuts on tape */
	tapes[i].ts_time  = 0;		/* no time used on tape */
	for (j=0; j < MAXTAPE; j++)
	{
		tapes[i].ts_tape[j].tape_rec = 0;	/* no album here */
		tapes[i].ts_tape[j].tape_cut = 0;	/* no cut here */
		tapes[i].ts_tape[j].tape_sec = 0;	/* no cut time */
		tapes[i].ts_tape[j].t_cname  = NULL;	/* no cut name */
		tapes[i].ts_tape[j].t_cart   = NULL;	/* no cut artist */
	}
}
