/*
 *
 * (c) Copyright 1992 by William R. Pringle - all rights reserved
 *
 *				**** FIND CD ****
 *
 * This routine searches the input file and returns a CD line and
 *	its location within the file.
 *
 * A return code < 0 implies end of file
 *
 */

#include <stdio.h>
#include "cd.h"

long
find_cd(infile,buf)
FILE *infile;			/* input file */
char *buf;				/* output buffer */
{
	long	loc;		/* seek location */
	char	*p;			/* return code for fgets */

	*buf = EOS;		/* initialize to white space */

	while (*buf == EOS || *buf == ' ' || *buf == '\t'
			|| *buf == '\n' || *buf == '\r')
	{		/* read the next line */
		loc = ftell(infile);	/* where we are */
		if (fgets(buf,BUFSIZ,infile) == NULL) return -1L;	/* end of file */
	}

		/* found a line starting with non-white space */
	for (p=buf; *p != EOS && *p != '\n' && *p != '\r' && *p != '\032'; p++);
	*p = EOS;		/* terminate line */
	return loc;		/* where line starts */
}
