/*
 *
 * (c) Copyright 1992 by William R. Pringle - all rights reserved
 *
 *				**** GET KEY ****
 *
 * EMACS_MODES: c, !fill, tabstop=4, !lnumb
 *
 * This routine takes a string and produces a key string
 *
 * A key string is formed by retaining only consonants and the letter U
 *
 */

#include <stdio.h>
#include <ctype.h>
#include "cd.h"

static	char	key_char[256];		/* which chars to keep for key */
static	char	*key_chars = "bcdfghjklmnpqrstuvwxyz0123456789";	/* these chars */

char *
get_key(str)
char	*str;		/* input string */
{	/* output is the key string for the input string */
	static	int	first_time = 1;			/* flag for first call */
	static	char	outbuf[BUFSIZ];		/* output string */
	char	*p, *q;						/* ptrs for scanning */
	int		lastchar;					/* test for duplicate chars */

	if (first_time) load_key_char();

		/* first, convert string to lower case */
		/* next, copy only those characters we care about */
	q = outbuf;		/* point to output string */
	lastchar = EOF;

	for (p=str; *p != EOS; p++)
	{
		if (isupper(*p)) *p = tolower(*p);
		if (key_char[*p])
		{		/* is a key character, copy it if not a duplicate */
			if (*p != lastchar) *q++ = *p;	/* copy char */
			lastchar = *p;					/* save last char copied */
		}
	}
	*q = EOS;				/* terminate output string */

	return outbuf;
}

load_key_char()
{		/* load which characters to keep for keys */
	int	i;

	for (i=0; i < sizeof(key_char); i++) key_char[i] = 0;
	for (i=0; key_chars[i] != EOS; i++) key_char[key_chars[i]] = i + 1;
}
