/*
 *
 * (c) Copyright 1992 by William R. Pringle - all rights reserved
 *
 *				**** OPEN OUT ****
 *
 * This routine opens output files
 *
 */

#include <stdio.h>
#include <ctype.h>
#include "cd.h"

FILE *
open_out(base,suffix,chk)
char	*base;
char	*suffix;
int		chk;			/* check for existing file */
{
	FILE	*fp;		/* file pointer */
	char	fname[BUFSIZ];	/* name buffer */
	char	buf[BUFSIZ];	/* input buffer */
	char	*p;				/* temp ptr */
	char	*open_mode;		/* open mode for file */

	strcpy(fname,base);
	strcat(fname,suffix);

	open_mode = FMODE_WRITE;		/* default is to clobber */
	while (chk)
	{		/* keep going until we get a valid open option */
		if (access(fname,0) == 0)
		{		/* already there, check it out */
			printf("File %s already exists.\n", fname);
			printf("Append, Overwrite, New Name, or Cancel? (a,o,n,c,?):");
			gets(buf);
			p = clean_up(buf);
			if (isupper(*p)) *p = tolower(*p);
			if (*p == 'c') return NULL;
			else if (*p == 'a') open_mode = FMODE_APP;
			else if (*p == 'o') open_mode = FMODE_WRITE;
			else if (*p == 'n')
			{
				printf("\nEnter new base name (1-8 chars): ");
				gets(buf);
				p = clean_up(buf);
				strcpy(fname,p);
				strcat(fname,suffix);
				continue;
			} else
			{
				printf("\nThe program is about to clobber %s.\n", fname);
				printf("You have several options.\n\n");
				printf("You can choose to overwrite the file, which will\n");
				printf("\tdestroy what was in it before.\n");
				printf("You can choose to append to the file, which will\n");
				printf("\tadd the data to the end of the existing file.\n");
				printf("You can choose to pick another file name.\n");
				printf("You can choose to cancel the request, which will\n");
				printf("\tterminate the program.\n");
				printf("\nEnter one of the following characters:\n");
				printf("\tA\tAdd to the end of the existing file.\n");
				printf("\tO\tTo clobber the existing file.\n");
				printf("\tN\tTo pick a new file name.\n");
				printf("\tC\tTo cancel & terminate program.\n");
				continue;
			}
		} else open_mode = FMODE_WRITE;
		break;		/* try to open the file */
	}	/* end loop for open option */

	if ((fp = fopen(fname,open_mode)) != NULL) return fp;

	fprintf(stderr,"%s: Unable to open output file %s\n", Prog, fname);
	perror(Prog);
	exit(1);
}
